<?PHP
$m = 'PstnHardware';
$berogui_path = "/usr/local/www/berogui";

/* [CHECKING SESSION] */
$newTarget = "/app/berogui/index.php?m=$m";
include($berogui_path .'/includes/session.php');
unset($newTarget);

/* [INCLUDE] */
include_once($berogui_path ."/misc/database.php");
include_once($berogui_path ."/includes/Helper/Helper.php");
include_once($berogui_path ."/includes/Helper/HelperPstn.php");

/* [FUNCTIONS] */
/**
 * Speichert den Clock-Parameter (Syncronization port) in der Dabenbank
 * @param beroAri $database
 * @param string $table Name der Datenbanktabelle
 */
function clock($database, $table, $post) {
	$query_new = $database->update("UPDATE $table SET clock=0");
	for ($i = 0; $i < Helper::getLifCount(); $i++) {
		if (isset($post['sync_li' . $i])) {
			$clock = preg_replace("/$table-/", "", $_POST['sync_li' . $i]);
			$database->update("UPDATE $table SET clock=1 WHERE port='" . $clock . "'");
		}
		if ($post['sync_li' . $i] == 'crystal') {
			$database->set("sync_port_li" . $i, '1');
		}
		else {
			$database->set("sync_port_li" . $i, '0');
		}
		if ($post['sync_li' . $i] == 'auto') {
			$database->set("sync_port_auto" . $i, '1');
		}
		else {
			$database->set("sync_port_auto" . $i, '0');
		}
	}
}

function regroupIsdn($database, $entry = null) {
	if (!is_null($entry)) {
		$where = " where lif>" . $entry['lif'];
	}
	$query_isdn = $database->select("select * from isdn" . $where);
	$database->delete("delete from isdn" . $where);
	if (!is_null($entry)) {
		$database->insert_('INSERT INTO isdn (type, lif, port_type,ccs) ' .
				'VALUES (\'' . $entry['type'] . '\',\'' . $entry['lif'] . '\',\'PRI\',1);');
	}
	while ($entry = $database->fetch_array($query_isdn)) {
		$database->insert_('INSERT INTO isdn (type, lif, port_type, clock) ' .
			'VALUES (\'' . $entry['type'] . '\',\'' . $entry['lif'] . '\',\'' . $entry['port_type'] . '\',\'' . $entry['clock'] . '\');');
	}
}



/*
 * Function to change the hardware configuration depending the $_POST input
 *
 */
function saveHardwareConfiguration($ba, $post_array) {
	if (isset($post_array['pcm_server'])) {
		$ba->set('pcm_server', '1');
	} 
	else {
		$ba->set('pcm_server', '0');
	}

	if ($post_array['master'] == "pcm") {
		$ba->set('pcm_server', sqlite_escape_string($post_array['pcm_ip']));
	}

	$ba->set('pcm_server_port', sqlite_escape_string($post_array['pcm_server_port']));

	//Country Settings
	if (isset($post_array['country'])) {
		$ba->set('country', sqlite_escape_string($post_array['country']));
	} 
	else {
		$ba->set('country', '');
	}

	if (isset($post_array['ohs'])) {
		$ohs = explode("|", $post_array['ohs']);
		$ohs1 = explode("=", $ohs[0]);
		$ohs2 = explode("=", $ohs[1]);
		$ba->set('ohs', sqlite_escape_string($ohs1[1]));
		$ba->set('ohs2', sqlite_escape_string($ohs2[1]));
	} 
	else {
		$ba->set('ohs', '0');
		$ba->set('ohs2', '0');
	}

	if (isset($post_array['rt'])) {
		$rt = explode("|", $post_array['rt']);
		$rt1 = explode("=", $rt[0]);
		$rt2 = explode("=", $rt[1]);
		$ba->set('rt', sqlite_escape_string($rt1[1]));
		$ba->set('rt2', sqlite_escape_string($rt2[1]));
	}
	else {
		$ba->set('rt', '0');
		$ba->set('rt2', '0');
	}

	(isset($post_array['rz'])) ? $ba->set('rz', sqlite_escape_string($post_array['rz'])) : $ba->set('rz', '0');
	(isset($post_array['dcv'])) ? $ba->set('dcv', sqlite_escape_string($post_array['dcv'])) : $ba->set('dcv', '0x0');
	(isset($post_array['mini'])) ? $ba->set('mini', sqlite_escape_string($post_array['mini'])) : $ba->set('mini', '0x0');
	(isset($post_array['acim'])) ? $ba->set('acim', sqlite_escape_string($post_array['acim'])) : $ba->set('acim', '0x0');
	(isset($post_array['ilim'])) ? $ba->set('ilim', sqlite_escape_string($post_array['ilim'])) : $ba->set('ilim', '0');

	//END Country settings
	if (isset($post_array['boostringer'])) {
		$ba->set('boostringer', sqlite_escape_string($post_array['boostringer']));
	}
	else {
		$ba->set('boostringer', '0');
	}

	//ISDN clock
	clock($ba, "isdn", $post_array);

	//CAS clock
	clock($ba, "cas", $post_array);

	$revision = Helper::getRevision();
	if (isset($post_array['portswitch']) && $revision != "1.80" && $revision != "1.8" && Helper::getType() < 30) {
		$ba->set('portswitch', '1');
	}
	else if (!isset($post_array['portswitch']) && $revision != "1.80" && $revision != "1.8" && Helper::getType() < 30) {
		$ba->set('portswitch', '0');
	}

	$id = $post_array['id_upd'];
	$type_array = $post_array['type'];
	$update_cas_channels = false;
	for ($i = 0; $i < count($id); $i++) {
		$id_upd = $id[$i];
		$type = $type_array[$i];
		//ISDN spezifieche Einstellungen speichern
		if ($type == "isdn") {
			$mode = "mode" . $id_upd;
			$mode_id = $post_array[$mode];
			$ptp = "ptp" . $id_upd;
			$ptp_id = $post_array[$ptp];
			$lt = "lt" . $id_upd;
			$lt_id = $post_array[$lt];
			$crystal_clock = "crystal_clock" . $id_upd;
			$crystal_clock_id = $post_array[$crystal_clock];
			$permanentl1 = "permanentl1" . $id_upd;
			$permanentl1_id = $post_array[$permanentl1];
			$crc = "crc" . $id_upd;
			$crc_id = $post_array[$crc];
			if ($ptp_id == "") {
				$ptp_id = "1";
			}
			if ($permanentl1_id == "") {
				$permanentl1_id = "0";
			}
			if ($lt_id == "") {
				$lt_id = "0";
			}
			if ($crc_id == "") {
				$crc_id = "0";
			}

			$query = $ba->select("select port_type from isdn where port = " . $id_upd);
			$isdn_port_type= sqlite_fetch_single($query);
				
			$crlen = "crlen" . $id_upd;
			$crlen_id = $post_array[$crlen];
			$cidlen = "cidlen" . $id_upd;
			$cidlen_id = $post_array[$cidlen];
				
			if ($isdn_port_type == "BRI") {
				if ($crlen_id == "") {
						$crlen_id= "1";
				}
				if ($cidlen_id== "") {
					$cidlen_id= "1";
				}
			}
				
			$query_upd = $ba->update("UPDATE isdn SET ntteHW='" . sqlite_escape_string($mode_id) . "',"
						. " ntteSW='" . sqlite_escape_string($mode_id) . "',"
						. " ptp='" . sqlite_escape_string($ptp_id) . "',"
						. " lt='" . sqlite_escape_string($lt_id) . "',"
						. " crc='" . sqlite_escape_string($crc_id) . "',"
						. " crystal_clock='" . sqlite_escape_string($crystal_clock_id) . "',"
						. " permanentl1='" . sqlite_escape_string($permanentl1_id) . "',"
						. " crlen='" . sqlite_escape_string($crlen_id) . "',"
						. " cidlen='" . sqlite_escape_string($cidlen_id) . "'"
						. " WHERE port='" . sqlite_escape_string($id_upd) . "'"
			);
		}

		//CAS speichern
		if ($type == "cas") {
			$termination = $post_array["casmode" . $id_upd];
			if ($termination == "") {
				$termination = "te";
			}
			$coding = $post_array["coding" . $id_upd];
			$query_upd = $ba->update("UPDATE cas SET termination='" . sqlite_escape_string($termination) . "', coding='" . sqlite_escape_string($coding) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");
		}
			
		//LTE speichern
		if ($type == "lte") {
			$pin = $post_array["pinlte" . $id_upd];
			$smsc = $post_array["smsclte" . $id_upd];
			//disabled codec for lte
			$codec = $post_array["codeclte" . $id_upd];
			$provider_mode = $post_array["provider_mode" . $id_upd];
			$provider_id = $post_array["provider_ids" . $id_upd];

			if ($provider_mode == 0) {
				$provider_id = "";
			}
			else if ($provider_id == "Scanning Now" || $provider_id == "No Scan Results" || $provider_id == "No ISGW" || $provider_id == "--------") {
				$provider_mode = 0;
				$provider_id = "";
			}
				
			$provider = $provider_mode . ":" . $provider_id;

			$codec_id = null;
			if (is_array($codec)) {
				foreach ($codec as $value) {
					$codec_id .=($codec_id == "") ? "" : "|";
					$codec_id.=$value;
				}
			}
			$query_upd = $ba->update("UPDATE lte SET pin='" . sqlite_escape_string($pin) . "', "
				. "smsc='" . sqlite_escape_string($smsc) . "', codec='" . sqlite_escape_string($codec_id)  . "', provider='" . sqlite_escape_string($provider) . "'  WHERE port='" . sqlite_escape_string($id_upd) . "'");
		}
			
		//GSM speichern
		if ($type == "gsm") {
			$pin = $post_array["pingsm" . $id_upd];
			$smsc = $post_array["smscgsm" . $id_upd];
			$codec = $post_array["codecgsm" . $id_upd];
			$codec_id = null;
			if (is_array($codec)) {
				foreach ($codec as $value) {
					$codec_id .=($codec_id == "") ? "" : "|";
					$codec_id.=$value;
				}
			}
			$query_upd = $ba->update("UPDATE gsm SET pin='" . sqlite_escape_string($pin) . "', "
				. "smsc='" . sqlite_escape_string($smsc) . "', codec='" . sqlite_escape_string($codec_id) . "'  WHERE port='" . sqlite_escape_string($id_upd) . "'");
		}

		//CAS Hardware modus Änderungen
		if ($type == "cashw") {
			$t1e1 = $post_array["t1e1" . $id_upd];
			if ($t1e1 == 1) {
				$protocol = "t1";
			}
			else {
				$protocol = "e1";
			}
			$interface_type = $post_array["interface_type" . $id_upd];

			$query = $ba->select("select port_type from cas where port='" . sqlite_escape_string($id_upd) . "'");
			$old_interface_type = sqlite_fetch_single($query);
			if ($old_interface_type != $interface_type) {
				$update_isdn = true;
			}
			$query = $ba->select("select protocol from cas where port='" . sqlite_escape_string($id_upd) . "'");
			$old_protocol = sqlite_fetch_single($query);
			if ($old_protocol != $protocol) {
				$update_cas_channels = true;
			}
			$query_upd = $ba->update("UPDATE cas SET protocol='" . sqlite_escape_string($protocol) . "', port_type='" . sqlite_escape_string($interface_type) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");
			$ba->set('set_hw', 1);
		}
	}

	//Wenn das cas protokoll (t1 oder e1) sich geändert hat, werden alle
	//channels gelöscht und neu angeordnet
	if ($update_cas_channels == true || $update_isdn == true) {

		$query_del = $ba->delete("delete from isdn where ccs=1");
		$query_del = $ba->delete("delete from cas_channels");

		//Gespeicherte ISDN Ports in lif0 zurücksetzen
		$query = $ba->select("select port, type, port_type, protocol, lif from cas order by port");
		while ($entry = $ba->fetch_array($query)) {
			//CAS channels speichern
			if ($entry['protocol'] == 't1' && $entry['port_type'] == 'cas') {
				for ($j = 0; $j < 24; $j++) {
					$ba->insert_("INSERT INTO cas_channels (port) VALUES('" . $entry['port'] . "');");
				}
			}
			if ($entry['protocol'] == 'e1' && $entry['port_type'] == 'cas') {
				for ($j = 0; $j < 31; $j++) {
					$ba->insert_("INSERT INTO cas_channels (port) VALUES('" . $entry['port'] . "');");
					if ($j == 15) {
						$channel = $ba->rowid();
					}
				}
				//Sigchan weglassen
				$ba->delete("delete from cas_channels where channel='" . $channel . "';");
			}
			//Channels (HDLC) in der ISDN Tabelle speichern
			if ($entry['port_type'] == 'hdlc') {
				regroupIsdn($ba, $entry);
			}
		}
		regroupIsdn($ba);
	}

	//Master-Slave option speichern
	isset($post_array['master']) ? $ba->set('master', sqlite_escape_string($post_array['master'])) : $ba->set('master', 'all');
}


/* [MAIN VARIABLES] */
$exec_ajax = 1;
$invalid = array();

/* [CHECKING GET REQUEST] */
unset($_GET);

/* [CHECKING POST REQUEST] */
unset($_POST['m']);


$list_post = array(
	// GENERAL
	'id_upd' => 'id', 'master' => array('||', 'select', 'int>=0'), 'type' => 'select', 'portswitch' => 'bool',
	// PCM
	'pcm_ip' => 'hostname', 'pcm_server' => 'bool', 'pcm_server_port' => 'int-range',
	// COUNTRY
	'country' => 'select'   , 'ohs'  => 'select'   , 'rt' => 'select', 'rz'          => 'bool', 'dcv' => 'int-range',
	'mini'    => 'int-range', 'acim' => 'int-range', 'ilim' => 'bool', 'boostringer' => 'bool',
);

$list_post_options = array(
	'master'          => array('all', 'pcm')					,
	'type'            => array('analog', 'cas', 'gsm', 'isdn', 'lte')               ,
	'pcm_server_port' => array('min' => 1, 'max' => 65535)                          ,
	'country'         => HelperPstn::getCountriesList()                              ,
	'ohs'             => array('ohs=0|ohs2=0', 'ohs=0|ohs2=1', 'ohs=1|ohs2=0')      ,
	'rt'              => array('rt=0|rt2=0', 'rt=1|rt2=0', 'rt=1|rt2=1')            ,
	'dcv'             => array('min' => 0, 'max' => 4)  /*min = 0x0 - max = 0x3*/   ,
	'mini'            => array('min' => 0, 'max' => 4)  /*min = 0x0 - max = 0x3*/   ,
	'acim'            => array('min' => 0, 'max' => 15) /*min = 0x0 - max = 0xf*/	,
);

// TODO: instead defining a variable as 'casmode$i', use 'casmode[]'
// TODO: gather the module list into an unique file
$mode_isdn = array('nt', 'te');
$modules =  array('bf1S0', 'bf2S0', 'bf4S0', 'bf1E1', 'bf2E1', 'bf1GSM', 'bf2GSM', 'bf1LTE', 'bf2LTE', 'bf1FXS', 'bf2FXS', 'bf4FXS', 'bf8FXS', 'bf16FXS', 'bf32FXS', 'bf1FXO', 'bf2FXO', 'bf4FXO', 'bf8FXO', 'bf2S02FXS', 'bf1t1e1', 'bf2t1e1', 'bf4t1e1');

// TODO: this part shoud be avoided if we use 'my_parameter[]' instead of 'my_parameterId1', 'my_parameterId2' and so one
$generic_post = array(
	// GENERAL
	'interface_type' => 'select', 'card_type' => 'select',
	// ANALOG
	// CAS
	'casmode' => 'select', 'coding' => 'select', 'te1e1' => 'bool',
	// GSM 
	'pingsm' => 'int-length', 'smscgsm' => 'international-code', 'codecgsm' => 'select',
	// ISDN
	'mode'    => 'select', 'ptp'   => 'bool'     , 'lt'     => 'bool'      , 'permanentl1'   => 'bool',
	'crc'     => 'bool'  , 'crlen' => 'int-range', 'cidlen' => 'int-range' , 'crystal_clock' => 'bool',
	'sync_li' => 'match' ,
	// LTE
	'pinlte'        => 'int-length', 'smsclte' => 'international-code', 'codeclte' => 'select', 'provider_mode' => 'int-range',
	'provider_ids'  => array('||', 'select', 'config-option'),
);

$generic_options = array(
	'card_type'     => $modules                                     ,
	'casmode'       => $mode_isdn                                   ,
	'cidlen'        => array('min' => 0, 'max' => 2)                ,
	'codecgsm'      => array(1, 2, 4, 8, 16)                        ,
	'codeclte'      => array(1, 2, 4, 8, 16, 32, 64, 128)           ,
	'coding'        => array('B8ZS', 'AMI')                         ,
	'crlen'         => array('min' => 0, 'max' => 2)                ,
	'interface_type'=> $modules                                     ,
	'mode'          => $mode_isdn                                   ,
	'pingsm'        => array('operator' => '>', 'length' => 4)      ,
	'pinlte'        => array('operator' => '>', 'length' => 4)      ,
	'provider_ids'  => array('Scanning Now', 'No Scan Results', 'No ISGW', '--------'),
	'provider_mode' => array('min' => 0, 'max' => 2)                ,
	'sync_li'       => '^auto$|^crystal$|^isdn-[0-9]+|^cas-[0-9]+$'
);

foreach ($generic_post as $key => $value) {
	foreach($_POST as $param => $val) {
		unset($match);
		if (preg_match('/^'.$key.'([0-9]+)$/', $param, $match)) {
			$list_post[$match[0]] = $value;
			if (isset($generic_options[$key])) {
				$list_post_options[$match[0]] = $generic_options[$key];
			}
		}
	}
}

$_POST = Helper::sanitizePost($_POST, $list_post, $exec_ajax, $invalid, $list_post_options);

/* [EXECUTING AJAX] */
if (!$exec_ajax) {
        echo "<script>window.location='../../index.php?m=$m&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
        exit(1);
}

$ba = new beroAri();
saveHardwareConfiguration($ba, $_POST);
Helper::activate(3, true, $m, ACTIVATE);

echo "<script>window.location='../../index.php?m=$m'</script>";
exit(1);
?>
